/*
    Copyright (C) 2012 Bartosz Broda, Jacek Bochenek, Łukasz Biłeńkij, 
    Damian Jaworski, Wojciech Mazur, Dominik Piasecki, Maciej Piasecki, 
    Radosław Ramocki
    
    This program is free software; you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License as published by the Free
Software Foundation; either version 3 of the License, or (at your option)
any later version.

    This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. 

    See the LICENSE and COPYING files for more details.
*/

#include "MatrixSaverDenseMatrix.h"

MatrixSaverDenseMatrix::~MatrixSaverDenseMatrix()
{
	if(matrix!=NULL)
	{
		for(int i=0;i<numOfRows;i++)
			delete matrix[i];
		delete matrix;
	}
}
bool MatrixSaverDenseMatrix::isSimetrical(bool cmpSimetrical)
{
	Config* cfg = Config::getInstance();
	if(cmpSimetrical && cfg->kBestResults>=numOfRows && cfg->wordsFile=="")
	{
		isSimetric=true;
		return true;
	}
	else
	{
		isSimetric=false;
		return false;
	}
}
void MatrixSaverDenseMatrix::initialize()
{
	matrix = new double*[numOfRows];
	for(int i=0;i<numOfRows;i++)
		matrix[i]=new double[numOfRows];
}
void MatrixSaverDenseMatrix::finalize()
{
	std::ofstream outputFile(Config::getInstance()->resultsFile.c_str());
	for(int i=0;i<numOfRows;i++)
	{
		for(int j=0;j<numOfRows;j++)
			outputFile<<matrix[i][j]<<" ";
		outputFile<<std::endl;
	}
	outputFile.close();
}

void MatrixSaverDenseMatrix::addValues(int rowNumber,int numOfValues,int *indexTable,double *valueTable)
{
	for(int i=0;i<numOfValues;i++)
	{

		matrix[rowNumber][indexTable[i]]=valueTable[i];

		if(isSimetric)
			matrix[indexTable[i]][rowNumber] = valueTable[i];

	}

}
MatrixSaverDenseMatrix::MatrixSaverDenseMatrix(int numOfRows)
{
	this->numOfRows=numOfRows;
}
